﻿@using Microsoft.EntityFrameworkCore
@using Microsoft.Extensions.Localization
@using Sirkadirov.Overtest.SharedLibraries.ODataStoreLib.Models.TasksArchive
@using System.Threading

@inject IDbContextFactory<OvertestDatabaseContext> _dbContextFactory
@inject IStringLocalizer<CuratorInvites> _localizer

@inject ISnackbar _snackbar

<MudDialog>
    <TitleContent>
        <MudText Typo="Typo.h6">
            <MudIcon Icon="@Icons.Material.Filled.Edit" Class="mr-3 mb-n1"/>
            @(CompilerId is null ? _localizer["Новий компілятор"] : _localizer["Редагування"])
        </MudText>
    </TitleContent>
    <DialogContent>
        @if (_editModel is not null)
        {
            <EditForm Model="@_editModel" OnValidSubmit="OnValidSubmitAsync">
                <DataAnnotationsValidator/>
                
                @if (CompilerId is null)
                {
                    <MudCheckBox Label="@_localizer["Вказати власний ідентифікатор"]" Color="Color.Primary"
                                 @bind-Checked="_editModelAllowCustomId"></MudCheckBox>
                    
                    if (_editModelAllowCustomId)
                    {
                        <MudTextField Variant="Variant.Outlined" Label="@_localizer["Ідентифікатор"]"
                                      Class="my-3" For="@(() => _editModel.Id)" @bind-Value="_editModel.Id" />
                    }
                }

                <MudTextField Variant="Variant.Outlined" Label="@_localizer["Відображувана назва"]" Class="my-3"
                              For="@(() => _editModel.Title)" @bind-Value="_editModel.Title" />
                
                <MudTextField Variant="Variant.Outlined" Label="@_localizer["Підсвітка синтаксису"]" Class="mt-3 mb-0"
                              For="@(() => _editModel.SyntaxHighlighter)" @bind-Value="_editModel.SyntaxHighlighter" />
                
                <MudCheckBox Label="@_localizer["Зробити активним"]" Color="Color.Primary"
                             For="@(() => _editModel.Enabled)"@bind-Checked="_editModel.Enabled"></MudCheckBox>

                <MudContainer Class="d-flex justify-end align-center pa-0 ma-0">
                    <MudButton ButtonType="ButtonType.Submit" Variant="Variant.Filled" Color="Color.Primary"
                               StartIcon="@Icons.Material.Filled.Save">@_localizer["Зберегти"]</MudButton>
                </MudContainer>
            </EditForm>
        }
    </DialogContent>
    <DialogActions>
        @if (_editModelLoadingData)
        {
            <MudProgressLinear Color="Color.Primary" Indeterminate="true" Class="ma-0" />
        }
    </DialogActions>
</MudDialog>

@code {
    private SemaphoreSlim _semaphore;
    
    [CascadingParameter] public MudDialogInstance MudDialog { get; set; }
    [Parameter] public Guid? CompilerId { get; set; }

    private Compiler _editModel;
    private bool _editModelAllowCustomId;
    private bool _editModelLoadingData;
    
    protected override async Task OnInitializedAsync()
    {
        await base.OnInitializedAsync();
        _semaphore = new SemaphoreSlim(1, 1);
        _editModelAllowCustomId = false;
        _editModelLoadingData = false;
    }

    protected override async Task OnParametersSetAsync()
    {
        await base.OnInitializedAsync();

        _editModelLoadingData = true;
        StateHasChanged();
        
        if (CompilerId is null)
        {
            _editModel = new Compiler { Enabled = true };
            _editModelAllowCustomId = false;
        }
        else
        {
            await using var databaseContext = _dbContextFactory.CreateDbContext();
            _editModel = await databaseContext.Compilers.AsNoTracking().FirstOrDefaultAsync(c => c.Id == CompilerId);
        }

        _editModelLoadingData = false;
        StateHasChanged();
    }

    private async Task OnValidSubmitAsync()
    {
        await _semaphore.WaitAsync();
        try
        {
            _editModelLoadingData = true;
            StateHasChanged();
            
            await using var databaseContext = _dbContextFactory.CreateDbContext();

            if (CompilerId is null)
            {
                if (!_editModelAllowCustomId)
                    _editModel.Id = default;

                await databaseContext.Compilers.AddAsync(_editModel);
            }
            else
            {
                if (!await databaseContext.Compilers.AnyAsync(c => c.Id == CompilerId))
                {
                    _snackbar.Add(_localizer["Редагований вами компілятор вже не існує!"], Severity.Error);
                    return;
                }

                _editModel.Id = CompilerId.Value;
                databaseContext.Compilers.Update(_editModel);
            }

            await databaseContext.SaveChangesAsync();
        }
        finally
        {
            MudDialog.Close();
            _semaphore.Release();
        }
    }
}